import numpy

def calc_fdr(data):

    decoys = []
    scores = []

    for d in data:
        decoys.append(d['decoy'])
        scores.append(d['score'])

    decoys = numpy.asarray(decoys)
    scores = numpy.asarray(scores)

    sort_idx = numpy.argsort(scores)[::-1]

    decoys = decoys[sort_idx]
    scores = scores[sort_idx]

    cumdecoys = numpy.cumsum(decoys)
    cumtargets = numpy.cumsum(numpy.logical_not(decoys))

    fdr = numpy.minimum(1, cumdecoys / numpy.maximum(1, cumtargets))

    return fdr, scores

def calc_qval(data):
    fdr, scores = calc_fdr(data)
    q = numpy.zeros_like(fdr)

    cummin = max(fdr)
    for i in range(len(fdr)-1, -1, -1):
        cummin = min(cummin, fdr[i])
        q[i] = cummin

    return q, scores
